poj 3126 Prime Path(简单题)

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 13425 Accepted: 7580

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:
给定两个四位数a,b,皆为素数,求由a修改至b的最少需要的次数。要求每次只能修改一位,且修改后的数必须是素数。

思路:
由于数是四位数,每次修改一位,一共有9*9*9*9种情况,BFS,对于每种情况,如果修改后的数满足条件即入队。

代码:
1.最笨的方法:
//Memory Time
//308K  125MS
#include<iostream>
#include<queue>
#include<cstring>
#include<cmath>
using namespace std;

int vis[10000],dis[10000];//vis[]记录该数是否修改过,dis[]记录修改的步数

int judge(int num)//判断是否为素数
{
    int flag=1;
    for(int i=2;i*i<=num;i++){
        if(num%i==0){
            flag=0;break;
        }
    }
    return flag;
}

int main()
{
    int n,num1,num2;
    cin>>n;
    for(int i=0;i<n;i++)
    {
        int l;
        memset(vis,0,sizeof(vis));
        memset(dis,9999,sizeof(dis));
        cin>>num1>>num2;
        if(num1==num2)
        {
            cout<<0<<endl;
            continue;
        }
        queue<int> q;
        q.push(num1);
        dis[num1]=0;
        while(!q.empty())
        {
            l=q.front();
            q.pop();
            if(l==num2)
                break;
            for(int j=0;j<4;j++)
            {
                for(int k=0;k<=9;k++)
                {
                    int shu[4];
                    shu[0]=l%10;
                    shu[1]=(l%100-shu[0])/10;
                    shu[2]=(l%1000-shu[1]*10-shu[0])/100;
                    shu[3]=(l%10000-shu[2]*100-shu[1]*10-shu[0])/1000;
                    if(shu[j]==k)continue;
                    shu[j]=k;
                    int num3=shu[3]*1000+shu[2]*100+shu[1]*10+shu[0];//修改数

                    if(judge(num3)&& num3>999 && !vis[num3])//满足条件,入队
                    {
                        q.push(num3);
                        vis[num3]++;
                        dis[num3] = dis[l]+1;
                    }
                }
            }
        }
        if(dis[num2]>=9999)
            cout<<"Impossible"<<endl;
        else
            cout<<dis[num2]<<endl;
    }
    return 0;
}

2.剪枝优化
//Memory Time 
//212K   16MS 

#include<iostream>
using namespace std;

typedef class
{
	public:
		int prime;
		int step;
}number;

bool JudgePrime(int digit)
{
	if(digit==2 || digit==3)
		return true;
	else if(digit<=1 || digit%2==0)
		return false;
	else if(digit>3)
	{
		for(int i=3;i*i<=digit;i+=2)
			if(digit%i==0)
				return false;
		return true;
	}
}

int a,b;
bool vist[15000];
number queue[15000];

void BFS(void)
{
	int i;  //temporary
	int head,tail;
	queue[head=tail=0].prime=a;
	queue[tail++].step=0;
	vist[a]=true;

	while(head<tail)
	{
		number x=queue[head++];
		if(x.prime==b)
		{
			cout<<x.step<<endl;
			return;
		}

		int unit=x.prime%10;       //获取x的个位
		int deca=(x.prime/10)%10;  //获取x的十位

		for(i=1;i<=9;i+=2)     //枚举x的个位,保证四位数为奇数(偶数必不是素数)
		{
			int y=(x.prime/10)*10+i;
			if(y!=x.prime && !vist[y] && JudgePrime(y))
			{
				vist[y]=true;
				queue[tail].prime=y;
				queue[tail++].step=x.step+1;
			}
		}
		for(i=0;i<=9;i++)     //枚举x的十位
		{
			int y=(x.prime/100)*100+i*10+unit;
			if(y!=x.prime && !vist[y] && JudgePrime(y))
			{
				vist[y]=true;
				queue[tail].prime=y;
				queue[tail++].step=x.step+1;
			}
		}
		for(i=0;i<=9;i++)     //枚举x的百位
		{
			int y=(x.prime/1000)*1000+i*100+deca*10+unit;
			if(y!=x.prime && !vist[y] && JudgePrime(y))
			{
				vist[y]=true;
				queue[tail].prime=y;
				queue[tail++].step=x.step+1;
			}
		}
		for(i=1;i<=9;i++)     //枚举x的千位,保证四位数,千位最少为1
		{
			int y=x.prime%1000+i*1000;
			if(y!=x.prime && !vist[y] && JudgePrime(y))
			{
				vist[y]=true;
				queue[tail].prime=y;
				queue[tail++].step=x.step+1;
			}
		}

	}

	cout<<"Impossible"<<endl;
	return;
}

int main(void)
{
	int test;
	cin>>test;
	while(test--)
	{
		cin>>a>>b;
		memset(vist,false,sizeof(vist));
		BFS();
	}
	return 0;
}


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值